apiVersion: unfurl/v1alpha1
kind: Ensemble
spec:
  deployment_blueprints:
    gcp:
      title: Google Cloud Platform
      cloud: unfurl.relationships.ConnectsTo.GoogleCloudProject
      description: Deploy compute instances on Google Cloud Platform
      resource_templates:
        dockerhost:
          type: unfurl.nodes.DockerComputeHost
    aws:
      title: Amazon Web Services EC2
      cloud: unfurl.relationships.ConnectsTo.AWSAccount
      description:
      resource_templates:
        dockerhost:
          type: unfurl.nodes.DockerComputeHost
    aws-example:
      title: Amazon Web Services EC2
      cloud: unfurl.relationships.ConnectsTo.AWSAccount
      visibility: hidden
      description:
      resource_templates:
        compute:
          type: unfurl.nodes.EC2Compute
          properties:
            num_cpus: 2
            disk_size: 200GB
            mem_size: 1GB
            key_name: null

        dockerhost:
          type: unfurl.nodes.DockerComputeHost
          requirements:
            - host: compute

    selfhosted:
      title: Local Development      
      cloud:
      description: Deploy onto your own development machines.
      visibility: hidden
      resource_templates:
        dockerhost:
          type: unfurl.nodes.LocalDockerHost
    gcp-example: 
      title: Google Cloud Platform Example
      cloud: unfurl.relationships.ConnectsTo.GoogleCloudProject
      description: A complete example ready to deploy.      
      visibility: hidden
      resource_templates:
        the_app:
          type: SimpleApp
          properties:
            foo: test
        dockerhost:
          type: unfurl.nodes.DockerComputeHost
          requirements:
            - host: compute
        compute:
          type: unfurl.nodes.GCPComputeInstance
          properties:
            num_cpus: 2
            disk_size: 200GB
            mem_size: 1GB
  service_template:
    description:
    metadata:
      template_name: testing/simple-blueprint
      title: Simple blueprint
      template_author:
      template_version: 0.1
      livePreview: #url to a live preview
      image: # url to image
      sourceCodeUrl: # url to the source code repository
      deployments: 0
      webUrl: # url to the source project
      primaryDeploymentBlueprint: gcp

    repositories:
      types:
        url: https://gitlab.com/onecommons/unfurl-types

    imports:
      - file: service-template.yaml
        repository: types

    node_types:
      SimpleApp:
        derived_from: unfurl.nodes.ContainerApp
        requirements:
          - container:
              node: container_service
        properties:
          foo:
            type: string
            required: false

    topology_template:
      outputs:
        # NB: the app's url attribute will not be computed unless this is declared
        url: 
          value:
            eval: ::the_app::url

      substitution_mappings:
        node: the_app

      node_templates:
        the_app:
          type: SimpleApp

        container_service:
          type: unfurl.nodes.ContainerService
          properties:
            container:
              image: nginxdemos/hello
              ports:
                - 80:80
              environment:
                FOO:
                  eval: .configured_by::foo
          requirements:
            - host: 
                # dockerhost is defined in deployment blueprint
                node: dockerhost
